3 ### Build script for Debian packages
5 ### (c) 2008 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This program is free software; you can redistribute it and/or modify
11 ### it under the terms of the GNU General Public License as published by
12 ### the Free Software Foundation; either version 2 of the License, or
13 ### (at your option) any later version.
15 ### This program is distributed in the hope that it will be useful,
16 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ### GNU General Public License for more details.
20 ### You should have received a copy of the GNU General Public License
21 ### along with this program; if not, write to the Free Software Foundation,
22 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
24 ###--------------------------------------------------------------------------
25 ### Conventions for build systems.
27 ### This script is designed to work with a variety of `make'-based build
28 ### systems, but there are a number of conventions which must be followed if
29 ### this is going to work properly.
31 ### * There must be a `configure.ac', `configure.in', or `.links' file, or
32 ### a `.git' directory in the project top-level, so that we can find it.
34 ### * The following `make' variables must be assigned in the top-level
35 ### Makefile, after `mdw-build' has constructed it.
37 ### distdir The name of the top-level project directory in the
38 ### source distribution, and the base name for
39 ### distribution archives; should be of the form
40 ### `PROJECT-VERSION'.
42 ### The following `make' targets must be available in the top-level
45 ### dist Write to $(distdir).tar.gz a source distribution of
48 ### distcheck As for `dist', but also build and test the project.
50 ### * The source distribution constructed by `make dist' must contain a file
51 ### $(distdir)/RELEASE containing the release name. This isn't currently
52 ### tested, but it might be later.
56 ###--------------------------------------------------------------------------
59 unset checkout checkoutrev
62 unset sbuild sbuildsrv
63 unset upload uploadpath
65 unset build distcheck debian clean vpath native
67 "/etc/mdw-build.conf" \
68 "${XDG_CONFIG_HOME-$HOME/.config}/mdw-build.conf" \
71 if [ -f "$i" ]; then . "$i"; fi
75 eval "p=\${$var+t} q=\${$want+t}"
76 case $p,$q in t,*) ;; *,t) eval "$var=yes" ;; *) eval "$var=no" ;; esac
78 : ${checkout=yes} ${checkoutrev=HEAD}
80 : ${setup=yes} ${setupcmd=!guess}
88 default_depends sbuild sbuildsrv
89 default_depends sign signkey
90 default_depends upload uploadpath
91 default_depends dput dputtarget
92 : ${DEB_BUILD_OPTIONS=parallel=4}; export DEB_BUILD_OPTIONS
94 ###--------------------------------------------------------------------------
101 Usage: $prog [-v] BUILDOPT
110 [no]upload[=SERVER:PATH]
122 ## Parse simple options.
124 while getopts "hv" opt; do
131 shift $((OPTIND - 1))
133 ## Parse the build options.
136 eval "p=\${$want+t}\${$want-nil}"
139 nil) echo >&2 "$prog: $want not set"; exit 1 ;;
144 checkout) checkout=yes checkoutrev=HEAD ;;
145 checkout=*) checkout=yes checkoutrev=${opt#*=} ;;
146 release) build=release ;;
147 norelease) build=test ;;
148 setup) setup=yes setupcmd=!guess ;;
149 setup=*) setup=yes setupcmd=${opt#*=} ;;
150 upload) maybe_set upload uploadpath ;;
151 upload=*) upload=yes uploadpath=${opt#*=} ;;
152 sign) maybe_set sign signkey ;;
153 sign=*) sign=yes signkey=${opt#*=} ;;
154 sbuild) maybe_set sbuild sbuildsrv ;;
155 sbuild=*) sbuild=yes sbuildsrv=${opt#*=} ;;
156 dput) maybe_set dput dputtarget ;;
157 dput=*) dput=yes dputtarget=${opt#*=} ;;
158 make=*) make=${opt#*=} ;;
160 distcheck | debian | clean | vpath | native | test)
163 nocheckout | nosetup | nodistcheck | nodebian | \
164 noupload | nodput | noclean | novpath | nonative | notest | \
175 ## Parse DEB_BUILD_OPTIONS.
177 set -- $DEB_BUILD_OPTIONS
180 parallel=*) jobs=${opt#*=} ;;
186 case $jobs in 1) ;; *) makeopts="$makeopts -j$jobs" ;; esac
188 ###--------------------------------------------------------------------------
189 ### Utility functions.
191 ## File descriptor assignments:
193 ## 0 -- original stdin (never touched)
194 ## 1, 2 -- stdout, stderr, redirected to 3 while running comamnds
195 ## log -- logfile and original stderr (verbose), or logfile only (quiet);
196 ## captures command output
197 ## diag -- logfile; primary diagnostic output
198 ## term -- orginal stderr; secondary diagnostic output (with colours)
202 echo $message >&$diag
203 echo "$(tput bold; tput setaf $colour)$message$(tput sgr0; tput op)" >&$term
213 release) fail "$*" ;;
214 *) notify 5 "??? $*" ;;
229 nice "$@" 2>&$log {log}>&- {diag}>&- {term}>&- || fail "$1: exit $?"
232 run () { runx "$@" >&$log; }
235 echo -n "(test $*)" >&$diag
236 if "$@" >&$diag 2>&$diag {log}>&- {diag}>&- {term}>&-; then
245 ###--------------------------------------------------------------------------
248 ## Some preflight checks.
250 no,release) fail "refusing to make release build without testing" ;;
252 case $test,$distcheck in
254 info "forcing \`distcheck' off because tsting disabled"
259 ## Find the top-level package directory.
260 while [ ! -f configure.ac -a ! -f configure.in -a \
261 ! -f .links -a ! -d .git ]; do
264 fail "couldn't find top-level directory"
271 ## Build any necessary qualifiers.
273 case ${SBOX_SESSION_DIR+t},${DEB_BUILD_ARCH+t} in
274 t,t) qual=$qual$qualsep$DEB_BUILD_ARCH; qualsep=- ;;
275 t,*) fail "unknown build arch" ;;
278 ## Construct the output directory.
279 releasepath=$toppath/dist-$build$qual
280 chmod -R +w $releasepath 2>/dev/null || :
281 rm -rf $releasepath 2>/dev/null || :
283 logfile=$releasepath/mdw-build.log
285 exec {diag}>>$logfile || fail "Failed to create log."
287 no) exec {log}>&$diag ;;
288 yes) exec {log}> >(tee -a $logfile >&$term {term}>&- {diag}>&-) ;;
291 ## Repeat the earlier assignments for tbe benefit of the logfile.
292 assign toppath $toppath
293 assign releasepath $releasepath
294 assign logfile $logfile
296 ## Do we have a Git repository?
297 case "$checkout,$setup,$(yesno [ -d $toppath/.git ])" in
299 fail "Inconsistent options: can't check out without setup."
302 info "No Git repository found."
303 checkout=no gitver=none
307 [ "$(git ls-files -m)" = "" ] ||
308 warn "working tree has uncommitted changes"
312 ## Is there Debian build equipment?
313 case "$debian,$(yesno [ -d $toppath/debian ])" in
315 info "No debian directory found."
316 debian=no debver=none
322 debver=$(dpkg-parsechangelog | sed -n 's/^Version: //p')
323 debsrc=$(dpkg-parsechangelog | sed -n 's/^Source: //p')
324 debname=$(git config user.name) debemail=$(git config user.email)
328 ## Maybe check out a copy of the source.
332 run git clone -sn $toppath/.git _source
333 assign srcpath $releasepath/_source
335 run git update-ref refs/heads/mdw-build $checkoutrev ""
336 run git symbolic-ref HEAD refs/heads/mdw-build
337 run git read-tree --reset refs/heads/mdw-build
338 run git checkout-index -afu
339 assign gitversion "$(git describe --abbrev=4)"
342 assign srcpath $toppath
346 ## Check the version number.
348 case "$gitversion,$debver" in
352 dvref=$(echo "$debver" | tr '~' '_')
353 if [ "$gitversion" = "$dvref" ]; then
354 assign debversion "$debver"
356 warn "Git version $gitversion doesn't match Debian version $debver"
358 dver=$(echo $gitversion | sed 's/-/+/; s/-/./g')
359 case $debver in *~) dver=$debver$dver ;; esac
360 assign debversion "$dver"
366 ## Maybe refresh the build machinery.
371 if [ -f .links ]; then setupcmd=mdw-setup
372 elif [ -x autogen.sh ]; then setupcmd=./autogen.sh
373 elif [ -x setup ]; then setupcmd=./setup
374 elif [ -f configure.ac ]; then setupcmd="autoreconf -is"
375 else setupcmd=mdw-setup
383 ## Initialize the build directory.
384 case "$vpath,$(yesno [ -e $srcpath/configure ])" in
386 assign buildpath $releasepath/_build
389 run $srcpath/configure
392 info "VPATH build disabled"
393 assign buildpath $srcpath
399 info "no configure script"
400 assign buildpath $srcpath
405 ## Discover the release name.
406 cat >find-distdir.mk <<'EOF'
409 @bash -c 'echo >&$(fd) $(distdir)'
412 $({ $make -f find-distdir.mk print-distdir fd=$t >/dev/null 2>&1; } {t}>&1)
414 ## Get a tarball distribution.
417 run $make $makeopts distcheck
420 run $make $makeopts dist
428 if ! tar tf $buildpath/$distdir.tar.gz 2>/dev/null | grep -q RELEASE
430 fail "missing RELEASE file in distribution"
435 run mv $buildpath/$distdir.tar.gz .
438 run gpg -u$signkey -ab -o$distdir.tar.gz.gpg $distdir.tar.gz
442 ## Maybe build the Debian packages.
445 run tar xvfz $distdir.tar.gz
449 cat - debian/changelog >debian/changelog.new <<EOF
450 $debsrc ($debversion) experimental; urgency=low
452 * Hacking in process, not intended for release.
454 -- $debname <$debemail> $now
457 mv debian/changelog.new debian/changelog
460 sbuildargs=$sbuildsrv
461 case $sbuild,$build in
463 case $sign in yes) sbuildargs="-k$signkey $sbuildargs" ;; esac
466 if [ -d $toppath/dist-$build.pkgs ]; then
467 sbuildargs="-p$toppath/dist-$build.pkgs $sbuildargs"
471 case "$sbuild,$test, $DEB_BUILD_OPTIONS " in
472 yes,no,*) sbuildargs="-T $sbuildargs" ;;
475 DEB_BUILD_OPTIONS=${DEB_BUILD_OPTIONS+"$DEB_BUILD_OPTIONS nocheck"}
478 case $sbuild,$build,$sign in
479 yes,*) run mdw-sbuild $sbuildargs ;;
480 no,release,yes) run dpkg-buildpackage -k$signkey ;;
481 no,*) run dpkg-buildpackage -us -uc ;;
486 ## Maybe upload Debian packages.
488 case "$upload,$build" in
489 yes,test) info "Test build: not uploading." ;;
490 yes,release) run rsync $distdir.tar.gz $distdir.tar.gz.gpg $uploadpath ;;
492 case "$debian,$upload,$dput,$build" in
493 yes,yes,yes,release) run dput -f $dputtarget *.changes ;;
499 rm -rf $releasepath/$distdir
500 rm -rf $releasepath/_source
501 rm -rf $releasepath/_build
508 ###----- That's all, folks --------------------------------------------------